"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const boa = require('@pipcook/boa');
const detectronModelLoad = (data, model, args) => __awaiter(void 0, void 0, void 0, function* () {
    let { steps = 100000, modelDir } = args;
    const os = boa.import('os');
    const { DefaultTrainer } = boa.import('detectron2.engine');
    const { register_coco_instances } = boa.import('detectron2.data.datasets');
    const { trainLoader, validationLoader } = data;
    const cfg = model.config;
    if (trainLoader) {
        register_coco_instances("train_dataset", {}, data.trainAnnotationPath, path.join(data.trainAnnotationPath, '..'));
        cfg.DATASETS.TRAIN = ["train_dataset"];
        if (validationLoader) {
            register_coco_instances("val_dataset", {}, data.validationAnnotationPath, path.join(data.validationAnnotationPath, '..'));
            cfg.DATASETS.TEST = ["val_dataset"];
        }
        else {
            cfg.DATASETS.TEST = ["train_dataset"];
        }
        cfg.SOLVER.MAX_ITER = steps;
        cfg.OUTPUT_DIR = modelDir;
        os.makedirs(cfg.OUTPUT_DIR, boa.kwargs({ "exist_ok": true }));
        const trainer = DefaultTrainer(cfg);
        trainer.resume_or_load(boa.kwargs({ "resume": true }));
        trainer.train();
        return Object.assign(Object.assign({}, model), { model: trainer });
    }
    return model;
});
exports.default = detectronModelLoad;
//# sourceMappingURL=index.js.map